=== scripts/requirements.txt ===
Babel==2.17.0
clang-format==20.*
